<template lang="pug">
	button(:title="title" :class="[type, align]")
		i {{ name }}
</template>

<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
	props: {
		title: {
			type: String,
			default: null,
			required: false,
		},
		name: {
			type: String,
			default: 'ERROR',
			required: true,
		},
		type: {
			type: String,
			default: 'primary',
			validator: (value: string) => (['primary', 'accent', 'ghost'].indexOf(value) !== -1),
		},
		align: {
			type: String,
			default: '',
			validator: (value: string) => (['left', 'right', ''].indexOf(value) !== -1),
		},
	},
});
</script>

<style lang="scss" scoped>
@import "@/assets/style/_colors.scss";
@import "@/assets/style/_dimensions.scss";

button {
	margin: 5px;
	padding: 0 4px;
	height: $icon-size;
	display: inline-block;
	font-size: 13px;
	border: none;
	border-radius: 2px;
	cursor: pointer;
	transition: background-color 200ms;
	&::-moz-focus-inner {
		border: 0;
	}
}

i {
	font-family: 'Material Icons';
	font-weight: normal;
	font-style: normal;
	font-size: 28px;  /* Preferred icon size */
	display: inline-block;
	line-height: $icon-size;
	width: 100%;
	max-width: 100%;
	text-transform: none;
	letter-spacing: normal;
	word-wrap: normal;
	white-space: nowrap;
	direction: ltr;

	/* Support for all WebKit browsers. */
	-webkit-font-smoothing: antialiased;
	/* Support for Safari and Chrome. */
	text-rendering: optimizeLegibility;

	/* Support for Firefox. */
	-moz-osx-font-smoothing: grayscale;

	/* Support for IE. */
	font-feature-settings: 'liga';
}

.primary {
	color: $primary-txt-color;
	background-color: $primary-bg-color;
	&:hover {
		background-color: $primary-bg-color-hover;
	}
	&:active {
		background-color: $primary-bg-color-active;
	}
}

.accent {
	color: $accent-txt-color;
	background-color: $accent-bg-color;
	&:hover {
		background-color: $accent-bg-color-hover;
	}
	&:active {
		background-color: $accent-bg-color-active;
	}
}

.ghost {
	color: rgba(12, 12, 13, 0.8);
	background-color: transparent;
	&:hover {
		background-color: rgba(12, 12, 13, 0.1);
	}
	&:active {
		background-color: rgba(12, 12, 13, 0.2);
	}
}

.left {
	float: left;
}

.right {
	float: right;
}
</style>
